--- old/usr/src/uts/common/os/kstat_fr.c	Fri Jan 29 20:31:01 2016
+++ new/usr/src/uts/common/os/kstat_fr.c	Fri Jan 29 20:31:01 2016
@@ -22,6 +22,7 @@
  * Copyright (c) 1992, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2014, Joyent, Inc. All rights reserved.
  * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
+ * Copyright 2016 Garrett D'Amore
  */
 
 /*
@@ -148,6 +149,7 @@
 extern	int	vac;
 extern	uint_t	nproc;
 extern	time_t	boot_time;
+extern	hrtime_t	boot_hrtime;
 extern	sysinfo_t	sysinfo;
 extern	vminfo_t	vminfo;
 
@@ -162,6 +164,7 @@
 	kstat_named_t avenrun_5min;
 	kstat_named_t avenrun_15min;
 	kstat_named_t boot_time;
+	kstat_named_t boot_hrtime;
 	kstat_named_t nsec_per_tick;
 } system_misc_kstat = {
 	{ "ncpus",		KSTAT_DATA_UINT32 },
@@ -174,6 +177,7 @@
 	{ "avenrun_5min",	KSTAT_DATA_UINT32 },
 	{ "avenrun_15min",	KSTAT_DATA_UINT32 },
 	{ "boot_time",		KSTAT_DATA_UINT32 },
+	{ "boot_hrtime",	KSTAT_DATA_TIME },
 	{ "nsec_per_tick",	KSTAT_DATA_UINT32 },
 };
 
@@ -810,6 +814,7 @@
 	int myncpus = ncpus;
 	int *loadavgp = &avenrun[0];
 	time_t zone_boot_time;
+	hrtime_t zone_boot_hrtime;
 	clock_t zone_lbolt;
 	hrtime_t zone_hrtime;
 	size_t zone_nproc;
@@ -836,8 +841,10 @@
 		zone_boot_time = boot_time;
 		zone_lbolt = ddi_get_lbolt();
 		zone_nproc = nproc;
+		zone_boot_hrtime = boot_hrtime;
 	} else {
 		zone_boot_time = curproc->p_zone->zone_boot_time;
+		zone_boot_hrtime = curproc->p_zone->zone_boot_hrtime;
 
 		zone_hrtime = gethrtime();
 		zone_lbolt = (clock_t)(NSEC_TO_TICK(zone_hrtime) -
@@ -858,6 +865,7 @@
 	system_misc_kstat.avenrun_15min.value.ui32	= (uint32_t)loadavgp[2];
 	system_misc_kstat.boot_time.value.ui32		= (uint32_t)
 	    zone_boot_time;
+	system_misc_kstat.boot_hrtime.value.t		= zone_boot_hrtime;
 	system_misc_kstat.nsec_per_tick.value.ui32	= (uint32_t)
 	    nsec_per_tick;
 	return (0);
